osg::DispatchCompute Class Reference

`#include <DispatchCompute>`

Inheritance diagram for osg::DispatchCompute:

## Public Member Functions

| DispatchCompute (GLint numGroupsX=0, GLint numGroupsY=0, GLint numGroupsZ=0)
| DispatchCompute (const DispatchCompute &, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osg, DispatchCompute)
virtual void | compileGLObjects (RenderInfo &) const
virtual VertexArrayState * | createVertexArrayStateImplememtation (RenderInfo &) const
virtual void | drawImplementation (RenderInfo &renderInfo) const
void | setComputeGroups (GLint numGroupsX, GLint numGroupsY, GLint numGroupsZ)
void | getComputeGroups (GLint &numGroupsX, GLint &numGroupsY, GLint &numGroupsZ) const
Public Member Functions inherited from osg::Drawable
| Drawable ()
| Drawable (const Drawable &drawable, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Drawable)
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual void | computeDataVariance ()
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setInitialBound (const osg::BoundingBox &bbox)
const BoundingBox & | getInitialBound () const
const BoundingSphere & | getBound () const
const BoundingBox & | getBoundingBox () const
virtual BoundingSphere | computeBound () const
virtual BoundingBox | computeBoundingBox () const
void | setComputeBoundingBoxCallback (ComputeBoundingBoxCallback *callback)
ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback ()
const ComputeBoundingBoxCallback * | getComputeBoundingBoxCallback () const
virtual void | setShape (Shape *shape)
template<class T>
void | setShape (const ref_ptr< T > &shape)
Shape * | getShape ()
const Shape * | getShape () const
void | setSupportsDisplayList (bool flag)
bool | getSupportsDisplayList () const
void | setUseDisplayList (bool flag)
bool | getUseDisplayList () const
GLuint & | getDisplayList (unsigned int contextID) const
virtual void | setUseVertexBufferObjects (bool flag)
bool | getUseVertexBufferObjects () const
void | setUseVertexArrayObject (bool flag)
bool | getUseVertexArrayObject () const
virtual void | dirtyGLObjects ()
virtual unsigned int | getGLObjectSizeHint () const
void | draw (RenderInfo &renderInfo) const
void | drawInner (RenderInfo &renderInfo) const
void | setCreateVertexArrayStateCallback (CreateVertexArrayStateCallback *cb)
CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback ()
const CreateVertexArrayStateCallback * | getCreateVertexArrayStateCallback () const
VertexArrayState * | createVertexArrayState (RenderInfo &renderInfo) const
virtual VertexArrayState * | createVertexArrayStateImplementation (RenderInfo &renderInfo) const
void | setVertexArrayStateList (VertexArrayStateList &vasl)
VertexArrayStateList & | getVertexArrayStateList ()
const VertexArrayStateList & | getVertexArrayStateList () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
virtual void | setDrawCallback (DrawCallback *dc)
DrawCallback * | getDrawCallback ()
const DrawCallback * | getDrawCallback () const
virtual bool | supports (const AttributeFunctor &) const
virtual void | accept (AttributeFunctor &)
virtual bool | supports (const ConstAttributeFunctor &) const
virtual void | accept (ConstAttributeFunctor &) const
virtual bool | supports (const PrimitiveFunctor &) const
virtual void | accept (PrimitiveFunctor &) const
virtual bool | supports (const PrimitiveIndexFunctor &) const
virtual void | accept (PrimitiveIndexFunctor &) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
virtual void | traverse (NodeVisitor &)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Attributes

GLint | _numGroupsX
GLint | _numGroupsY
GLint | _numGroupsZ
Protected Attributes inherited from osg::Drawable
BoundingBox | _initialBoundingBox
ref_ptr< ComputeBoundingBoxCallback > | _computeBoundingBoxCallback
BoundingBox | _boundingBox
ref_ptr< Shape > | _shape
bool | _supportsDisplayList
bool | _useDisplayList
bool | _supportsVertexBufferObjects
bool | _useVertexBufferObjects
bool | _useVertexArrayObject
GLObjectList | _globjList
VertexArrayStateList | _vertexArrayStateList
ref_ptr< DrawCallback > | _drawCallback
ref_ptr< CreateVertexArrayStateCallback > | _createVertexArrayStateCallback
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Drawable

enum

AttributeTypes {
VERTICES = 0 , WEIGHTS = 1 , NORMALS = 2 , COLORS = 3 ,
SECONDARY_COLORS = 4 , FOG_COORDS = 5 , ATTRIBUTE_6 = 6 , ATTRIBUTE_7 = 7 ,
TEXTURE_COORDS = 8 , TEXTURE_COORDS_0 = TEXTURE_COORDS , TEXTURE_COORDS_1 = TEXTURE_COORDS_0+1 , TEXTURE_COORDS_2 = TEXTURE_COORDS_0+2 ,
TEXTURE_COORDS_3 = TEXTURE_COORDS_0+3 , TEXTURE_COORDS_4 = TEXTURE_COORDS_0+4 , TEXTURE_COORDS_5 = TEXTURE_COORDS_0+5 , TEXTURE_COORDS_6 = TEXTURE_COORDS_0+6 ,
TEXTURE_COORDS_7 = TEXTURE_COORDS_0+7
}

typedef DrawableUpdateCallback | UpdateCallback
typedef DrawableEventCallback | EventCallback
typedef DrawableCullCallback | CullCallback
typedef unsigned int | AttributeType
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Drawable
static GLuint | generateDisplayList (unsigned int contextID, unsigned int sizeHint=0)
static void | deleteDisplayList (unsigned int contextID, GLuint globj, unsigned int sizeHint=0)
static void | setMinimumNumberOfDisplayListsToRetainInCache (unsigned int minimum)
static unsigned int | getMinimumNumberOfDisplayListsToRetainInCache ()
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Types inherited from osg::Drawable
typedef osg::buffered_value< GLuint > | GLObjectList
Protected Member Functions inherited from osg::Drawable
Drawable & | operator= (const Drawable &)
virtual | ~Drawable ()
void | setBound (const BoundingBox &bb) const
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Detailed Description

Wrapper around glDispatchCompute.

## Constructor & Destructor Documentation

## DispatchCompute() [1/2]

osg::DispatchCompute::DispatchCompute | ( | GLint | numGroupsX = 0,
|  | GLint | numGroupsY = 0,
|  | GLint | numGroupsZ = 0 )

inline

References _numGroupsX, _numGroupsY, _numGroupsZ, and osg::Drawable::Drawable().

Referenced by DispatchCompute(), and META_Node().

## DispatchCompute() [2/2]

osg::DispatchCompute::DispatchCompute | ( | const DispatchCompute & | ,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References DispatchCompute(), and osg::CopyOp::SHALLOW_COPY.

## Member Function Documentation

## compileGLObjects()

virtual void osg::DispatchCompute::compileGLObjects | ( | RenderInfo & | renderInfo | ) | const

inline virtual

Immediately compile this `Drawable` into an OpenGL Display List/VertexBufferObjects.

Note
  Operation is ignored if `_useDisplayList` is `false` or VertexBufferObjects are not used.

Reimplemented from osg::Drawable.

## createVertexArrayStateImplememtation()

virtual VertexArrayState * osg::DispatchCompute::createVertexArrayStateImplememtation | ( | RenderInfo & |  | ) | const

inline virtual

## drawImplementation()

virtual void osg::DispatchCompute::drawImplementation | ( | RenderInfo & |  | ) | const

virtual

drawImplementation(RenderInfo&) is a pure virtual method for the actual implementation of OpenGL drawing calls, such as vertex arrays and primitives, that must be implemented in concrete subclasses of the Drawable base class, examples include osg::Geometry and osg::ShapeDrawable. drawImplementation(RenderInfo&) is called from the draw(RenderInfo&) method, with the draw method handling management of OpenGL display lists, and drawImplementation(RenderInfo&) handling the actual drawing itself. renderInfo : The osg::RenderInfo object that encapsulates the current rendering information including the osg::State OpenGL state for the current graphics context.

Reimplemented from osg::Drawable.

## getComputeGroups()

void osg::DispatchCompute::getComputeGroups | ( | GLint & | numGroupsX,
|  | GLint & | numGroupsY,
|  | GLint & | numGroupsZ ) const

inline

Get compute shader work groups

References _numGroupsX, _numGroupsY, and _numGroupsZ.

## META_Node()

osg::DispatchCompute::META_Node | ( | osg | ,
|  | DispatchCompute | )

References DispatchCompute().

## setComputeGroups()

void osg::DispatchCompute::setComputeGroups | ( | GLint | numGroupsX,
|  | GLint | numGroupsY,
|  | GLint | numGroupsZ )

inline

Set compute shader work groups

References _numGroupsX, _numGroupsY, and _numGroupsZ.

## Member Data Documentation

## _numGroupsX

GLint osg::DispatchCompute::_numGroupsX

protected

Referenced by DispatchCompute(), getComputeGroups(), and setComputeGroups().

## _numGroupsY

GLint osg::DispatchCompute::_numGroupsY

protected

Referenced by DispatchCompute(), getComputeGroups(), and setComputeGroups().

## _numGroupsZ

GLint osg::DispatchCompute::_numGroupsZ

protected

Referenced by DispatchCompute(), getComputeGroups(), and setComputeGroups().

The documentation for this class was generated from the following file:

- DispatchCompute